﻿@using DocumentFormat.OpenXml.Wordprocessing
@{
    ViewBag.Title = "Role Maintenance";
    Layout = "~/Views/Shared/_FixedLayout.cshtml";
}

<link href="~/Content/plugins/datatables/css/dataTables.bootstrap.css" rel="stylesheet" />
<script src="~/Content/plugins/datatables/js/jquery.dataTables.min.js"></script>
<script src="~/Content/plugins/datatables/js/jquery.dataTables.columnFilter.js"></script>
<script src="~/Content/plugins/datatables/js/dataTables.bootstrap.js"></script>


<script type="text/javascript">

    $(function () {
        $.ajax({
            url: '@Url.Action("GetStatus", "RoleMaintenance")',
            type: 'GET',
            dataType: 'json',
            success: function (results) {
                $.each(results, function (i, result) {
                    $('#ddlStatus').append('<option value="' + result.Value + '">' + result.Text + '</option>');
                });
            },
            error: function (ex) {
                $('#ddlStatus').append('<option >No data found</option>');
            }
        });
    });

    $(function () {
        $.ajax({
            url: '@Url.Action("GetAvailableMenu", "RoleMaintenance", new { RoleId = @ViewBag.RowId })',
            type: 'GET',
            dataType: 'json',
            success: function (results) {
                $.each(results, function (i, result) {
                    $('#ddlMenu').append('<option value="' + result.Value + '">' + result.Text + '</option>');
                });
            },
            error: function (ex) {
                $('#ddlMenu').append('<option value="0">No data found</option>');
            }
        });
    });

    var oTable;


    $(document).ready(function () {
        void function loadRole() {
            var GetDetail = '@Url.Action("GetRoleDetail", "RoleMaintenance", new { rowid = @ViewBag.RowId })';
            $.ajax(GetDetail, {
                contentType: 'application/json; charset=utf-8',
                dataType: 'json',
                type: 'POST',
                success: function (GetDetail) {
                    if (GetDetail.success) {
                        document.getElementById("txtRoleName").value = GetDetail.rolename;
                        document.getElementById("ddlStatus").value = GetDetail.rolestatus;
                    }
                },
                error: function () {

                }
            });
        }
        ();

        void function loadMenuList() {

            var aryColTableChecked = [];
            for (var idx = 1; idx < 4; idx++) {
                aryColTableChecked.push("field" + idx);
            }

            var aoColumnDef = [];

            $.each(aryColTableChecked, function (i, value) {

                var obj = {
                    "mData": value,
                    "aTargets": [i]
                }
                //if (i == 2) {
                //    var obj = {
                //        "mData": value
                //        , "visible": false
                //        , "aTargets": [i]
                //        , "searchable": false
                //    }
                //}
                if (i == 0) {
                    var obj = {
                        "mData": value,
                        "aTargets": [i],
                        "mRender": function (data, type, row) {
                            return '<a class="btn btn-primary btn-xs tblButton"  style="width: 30px;" name = "btnDelete" aria-label="Delete" data-id="' + data + '" ><i class="glyphicon glyphicon-trash"></i></a>';

                        },
                        "bSortable": false
                    }
                }
                aoColumnDef.push(obj);
            });

            if (oTable != null) {
                oTable.fnDestroy();
            }

            oTable = $('#tblData').dataTable({
                "sAjaxSource": "@Url.Action("GetMenuListDetail", "RoleMaintenance")",
                "bServerSide": false,
                "bProcessing": true,
                "bSort": false,
                "bPaginate": true,
                "bLengthChange": false,
                "bStateSave": false,
                "bDestroy": true,
                "bRetrieve": true,
                "fnServerData": function (sSource, aoData, fnCallback) {
                    $.ajax({
                        "dataType": "json",
                        "type": "POST",
                        "url": sSource,
                        "data": aoData,
                        "success": fnCallback
                    });
                },
                "sDom": '<"#tblData_header.clearfix "<"pull-left"l><"pull-right"r>><"table-responsive"t><"#ScrollTop"><"#tblData_footer.clearfix "<"pull-left"i><"pull-right"p>>',
                "fnServerParams": function (aoData) {
                    aoData.push({ "name": "rowid", "value": '@ViewBag.RowId' });
                },
                "aoColumnDefs": aoColumnDef,
                "iDisplayLength": 10,
                "oLanguage": {
                    "sProcessing": '<i class="fa fa-spinner fa-spin"></i> Retrieve Data ... ',
                    "sLengthMenu": '_MENU_'
                },
            });

            oTable.fnSettings().aoColumns[0].sClass = "text-center";
            oTable.fnSettings().aoColumns[1].sClass = "text-center";
            oTable.fnSettings().aoColumns[2].sClass = "text-center";
            

            $('#tblData tbody').on('click', 'a', function () {

                var table = $('#tblData').DataTable();
                var row = table.row($(this).parents('tr')).data();
                var action = $(this).attr('aria-label');
                var rowid = $(this).attr('data-id');

                if (action == 'Delete') {
                    bootbox.confirm({
                        title: "<i class='fa fa-warning fa-2x'></i> Delete Confirmation",
                        message: 'Are you sure you want to delete this data.',
                        className: "medium",
                        buttons: {
                            'cancel': {
                                label: '<i class="fa fa-times"></i> Cancel',
                                className: 'btn-default pull-left'
                            },
                            'confirm': {
                                label: '<i class="fa fa-check"></i> Yes, Continue delete',
                                className: 'btn-primary pull-right'
                            }
                        },
                        callback: function (result) {
                            if (result) {
                                @*var url = '@Url.Action("DeleteMenu", "RoleMaintenance")?rowid=' + rowid;*@
                                 $.ajax({
                                type: "POST",
                                url: '@Url.Action("DeleteMenu", "RoleMaintenance")?rowid=' + rowid,
                                dataType: 'json',
                                contentType: false,
                                processData: false,
                                //beforeSend: function () {
                                //    //$("#loader").show();
                                //},
                                success: function (data) {
                                    bootbox.dialog({
                                        message: data.message,
                                        title: data.title,
                                        buttons: {
                                            main: {
                                                label: "<i class='fa fa-check'></i> Ok",
                                                className: "btn-primary",
                                                callback: function () {
                                                    if (result) {
                                                        if (data.status) {
                                                            oTable.fnPageChange('first');
                                                            location.reload(true);
                                                            @*window.location.href = '@Url.Action("EditRole", "RoleMaintenance")?id=' + '@ViewBag.RowId';*@
                                                        }
                                                    }
                                                }
                                            }
                                        }
                                    });
                                }
                            });
                        }

                    }
                    });
            }


            });
    }();


    $("#btnAddMenu").click(function () {
        //validation
        if ($('#ddlMenu').val() == '0'){
            bootbox.alert("<i class='fa fa-warning fa-2x'></i> No avaliable menu", function () {
                setTimeout(function () { }, 500);
            });
        } else {

            //confirmation
            bootbox.confirm({
                title: "<i class='fa fa-warning fa-2x'></i> Save Confirmation",
                message: 'Are you sure you want to add this menu. <br>If not, click Cancel',
                buttons: {
                    'cancel': {
                        label: '<i class="fa fa-times"></i> Cancel',
                        className: 'btn-default pull-left'
                    },
                    'confirm': {
                        label: '<i class="fa fa-check"></i> Yes, Continue save',
                        className: 'btn-primary pull-right'
                    }
                },
                callback: function (result) {
                    if (result) {
                        var MenuList = [
                             {
                                 roleid: '@ViewBag.RowId'
                                 , menuid: $('#ddlMenu').val()
                             }
                        ];

                        MenuList.push();

                        var formData = new FormData();
                        formData.append("MenuList", JSON.stringify(MenuList));


                        //Save Process
                        $.ajax({
                            type: "POST",
                            url: '@Url.Action("AddMenu", "RoleMaintenance")',
                            data: formData,
                            dataType: 'json',
                            contentType: false,
                            processData: false,
                            //beforeSend: function () {
                            //    //$("#loader").show();
                            //},
                            success: function (data) {
                                bootbox.dialog({
                                    message: data.message,
                                    title: data.title,
                                    buttons: {
                                        main: {
                                            label: "<i class='fa fa-check'></i> Ok",
                                            className: "btn-primary",
                                            callback: function () {
                                                if (result) {
                                                    if (data.status) {
                                                        window.location.href = '@Url.Action("EditRole", "RoleMaintenance")?id=' + '@ViewBag.RowId';
                                                    }
                                                }
                                            }
                                        }
                                    }
                                });
                            }
                        });

                    }
                }
            });
        }


    });

    $("#btnSave").click(function () {
        //validation
        if ($('#txtRoleName').val().length == 0) {
            bootbox.alert("<i class='fa fa-warning fa-2x'></i> Please fill mandatory field (<label class='required'></label>)", function () {
                setTimeout(function () { }, 500);
            });
        } else {

            //confirmation
            bootbox.confirm({
                title: "<i class='fa fa-warning fa-2x'></i> Save Confirmation",
                message: 'Are you sure you want to save this data. <br>If not, click Cancel',
                buttons: {
                    'cancel': {
                        label: '<i class="fa fa-times"></i> Cancel',
                        className: 'btn-default pull-left'
                    },
                    'confirm': {
                        label: '<i class="fa fa-check"></i> Yes, Continue save',
                        className: 'btn-primary pull-right'
                    }
                },
                callback: function (result) {
                    if (result) {
                        var RoleList = [
                             {
                                 roleid: '@ViewBag.RowId'
                                 , rolename: $('#txtRoleName').val()
                                 , status: $('#ddlStatus').val()
                             }
                        ];

                        RoleList.push();

                        var formData = new FormData();
                        formData.append("RoleList", JSON.stringify(RoleList));


                        //Save Process
                        $.ajax({
                            type: "POST",
                            url: '@Url.Action("SaveRole", "RoleMaintenance")',
                            data: formData,
                            dataType: 'json',
                            contentType: false,
                            processData: false,
                            //beforeSend: function () {
                            //    //$("#loader").show();
                            //},
                            success: function (data) {
                                bootbox.dialog({
                                    message: data.message,
                                    title: data.title,
                                    buttons: {
                                        main: {
                                            label: "<i class='fa fa-check'></i> Ok",
                                            className: "btn-primary",
                                            callback: function () {
                                                if (result) {
                                                    if (data.status) {
                                                        window.location.href = '@Url.Action("Role", "RoleMaintenance")';
                                                    }
                                                }
                                            }
                                        }
                                    }
                                });
                            }
                        });

                    }
                }
            });
        }


    });

    });


</script>

<style>
    .label-def-margin {
        margin-top: 6px;
    }

    .required:after {
        content: "*";
        color: red;
    }
</style>


<div class="col-sm-12">
    <div class="panel panel-primary" style="margin-bottom: 0;">
        <div class="panel-heading">
            Edit Role

        </div>
        <div class="panel-body">

            <!--Role Name-->
            <div class="row">
                <div class="col-sm-2"><label class="required label-def-margin" for="txtRoleName">Role Name</label></div>
                <div class="col-sm-4"><input class="form-control" type="text" id="txtRoleName" /></div>
            </div>
            <!--Role Status-->
            <div class="row">
                <div class="col-sm-2"><label class="label-def-margin" for="ddlStatus">Status</label></div>
                <div class="col-sm-3"><select class="form-control" id="ddlStatus"></select></div>
            </div>
            <!--Menu Add-->
            <div class="row">
                <div class="col-sm-2"><label class="label-def-margin" for="ddlMenu">Menu</label></div>
                <div class="col-sm-3"><select class="form-control" id="ddlMenu"></select></div>
                <div class="col-sm-3">
                    <button type="button" class="btn btn-primary" id="btnAddMenu" name="btnAddMenu" >
                        <span class="glyphicon glyphicon-plus-sign"></span> Add Menu
                    </button>
                </div>
            </div>
            
            <!--Menu List-->

            <table id="tblData" class="table table-striped table-hover table-bordered" width="100%" style="font-size: 10px; margin-top: 0 !important; margin-bottom: 0 !important; padding-top: 0 !important; padding-bottom: 0 !important;">
                <thead class="bg-mantle-gradient">
                    <tr>
                        <th>Action &nbsp; </th>
                        <th>Menu Name &nbsp; </th>
                        <th>Group Menu &nbsp; </th>
                    </tr>
                </thead>
            </table>

        </div>
        <div class="panel-footer">
            <div class="row">
                <div class="col-sm-12">
                    <button type="button" class="btn btn-primary" id="btnSave">
                        <span class="glyphicon glyphicon-floppy-disk"></span> Save
                    </button>
                    &nbsp;
                    <button type="button" class="btn btn-primary" onclick="@("window.location.href='" + @Url.Action("BackRole", "RoleMaintenance") + "'");">
                        <span class="glyphicon glyphicon-circle-arrow-left"></span> Back
                    </button>
                </div>
            </div>
        </div>



    </div>
</div>
